function love.load()
    game = {
        player = {
            x = love.graphics.getWidth() / 2 - 100,
            y = 0,
        },
        pipe_down = {
            x = love.graphics.getWidth(),
            y = love.graphics.getHeight() / 2 ,
            hight = love.math.random(-50, -100),
        },
        pipe_up = {
            x = love.graphics.getWidth(),
            y = 0,
            hight = love.math.random(50, 100),
        },
        lost = false
    }
    function game.cos_det (x1, y1, x2, y2) -- collision dectition (up pipe)
        if x1 + 40 > x2 and math.abs(x1 + 40 - x2) < 100 and y1 < y2 then
            return(true)
        else
            return(false)
        end
    end
    function game.cos (x1, y1, x2, y2) --collission dectition (down pipe)
        if x1 + 40 > x2 and math.abs(x1 + 40 - x2) < 100 and y1 + 40 > y2 then
            return(true)
        else
            return(false)
        end
    end
    co = game.cos -- shortcut
    cos = game.cos_det -- shortcut
    pipe_d = game.pipe_down -- shortcut
    pipe_u = game.pipe_up -- shortcut
    player = game.player -- shortcut
    lost = game.lost --shortcut
end
function love.update(dt)
    if love.keyboard.isDown("space") then
        player.y = player.y - 10 * dt
    end
    if not(player.y + 40 == love.graphics.getHeight() / 2) then
        player.y = player.y + 5 * dt
    end
    if player.y < 0 then
        player.y = player.y + 5 * dt
    end
    if not(pipe_d.x == 0 or pipe_d.x < 0 and pipe_u.x == 0 or pipe_u.x < 0)then
        pipe_d.x = pipe_d.x - 5 * dt
        pipe_u.x = pipe_u.x - 5 * dt
    else
        math.randomseed(os.time())
        pipe_d.hight = -love.math.random(50, 100)
        pipe_u.hight = love.math.random(50, 100)
        pipe_d.x = love.graphics.getWidth()
        pipe_u.x = love.graphics.getWidth()
    end
    if cos(player.x, player.y, pipe_u.x, math.abs(pipe_u.y + pipe_u.hight)) == true then
        love.window.setTitle("You lost !")
        lost = true
    end
    if co(player.x, player.y, pipe_d.x, pipe_d.y + pipe_d.hight) == true then
        love.window.setTitle("You lost !")
        lost = true
    end
end
function love.draw()
    if not(lost == true) then
        love.graphics.rectangle("line", player.x, player.y, 40, 40) -- player
        love.graphics.rectangle("line", 0, love.graphics.getHeight() / 2, love.graphics.getWidth(), love.graphics.getHeight() / 2) -- ground
        love.graphics.rectangle("fill", pipe_d.x, pipe_d.y, 100, pipe_d.hight) -- down pipe
        love.graphics.rectangle("fill", pipe_u.x, pipe_u.y, 100, pipe_u.hight) --up pipe
    else
        love.graphics.printf("You lost ! \n Press esc to exit !", 0, love.graphics.getHeight() / 2, love.graphics.getWidth(), "center")
        if love.keyboard.isDown("escape") then
            love.event.quit(1)
        end
    end
end
